#include <stdbool.h>

// #### OpenClose.c
int ConnectToPrinter(const char *port);
void DisconnectPrinter();

int PrintDeviceFont(const char *text, const int xPos, const int yPos, const int fontName, 
					const int xMulti, const int yMulti, const int rotation, const bool bold);

int PrintVectorFont(const char *text, const int xPos, const int yPos, const int font, 
					const int fontWidth, const int fontHeight,
					const int rightSpace, const bool bold, const bool reverse, const bool italic,
					const int rotation, const int alignment, int printDirection);

int PrintDeviceFontW(const char *text, const int xPos, const int yPos, const int fontName, 
					const int xMulti, const int yMulti, const int rotation, const bool bold, 
					const unsigned codePage);

int PrintVectorFontW(const char *text, const int xPos, const int yPos, const int font, 
					const int fontWidth, const int fontHeight,
					const int rightSpace, const bool bold, const bool reverse, const bool italic,
					const int rotation, const int alignment, int printDirection, const unsigned int codePage);

int ClearBuffer();
int DirectIO(const char *writeData, const int writeLen, char *readData, int *readLen);
int Prints(const int nLabelSet, const int nCopies);

int PrintBlock(const int xStart, const int yStart, const int xEnd, const int yEnd,
			   const int option, const int thickness);
int PrintCircle(const int xPos, const int yPos, int size, int multi);
int InitializePrinter();
int CalibrateMedia();
int ResetPrinter();
int FeedOneLabel();

int SetSpeed(int speed);
int SetDensity(int density);
int SetOrientation(int orientation);
int SetCutter(bool autoCut, int cutPeriod);
int SetBackFeed(bool backFeeding);
int SetPaper(int width, int height, int mediaType, int offset, int gapLength);
int SetPrintingType(int type);
int SetMargin(int horizontalMargin, int verticalMargin);
int SetOffset(int offset);

int SetCharacterSet(int ICS, int codePage);

int Print1DBarcode(const char *barcodeData, const int xPos, const int yPos, int barcodeType, 
				const int narrowBarWidth, const int wideBarWidth, const int barcodeHeight, int rotation, int HRI);
int PrintMaxiCode(const char *barcodeData, const int xPos, const int yPos, int mode);
int PrintPDF417(const char *barcodeData, const int xPos, const int yPos, int verticalCount, int HorizontalCount,
		  int errLevel, int dataComp, bool HRI, int startPosition, int moduleWidth, int barHeight, int rotation);
int PrintQRCode(const char *barcodeData, const int xPos, const int yPos, int model, const int eccLevel, 
			int barSize, int rotation);
int PrintDataMatrix(const char *barcodeData, const int xPos, const int yPos, int barSize, 
			const bool reverse, int rotation);
int PrintAztec(const char *barcodeData, const int xPos, const int yPos, int barSize, int interpretation,
			int errCodeNSymbolSize, bool menuSymbol, int numOfSymbol, int optID, int rotation);
int PrintCode49(const char *barcodeCmd, const int xPos, const int yPos, const int narrowWidth,
			const int wideWidth, const int barHeight, int HRI, int startingMode, int rotation);
int PrintCODABLOCK(const char *barcodeData, const int xPos, const int yPos, const int narrowWidth,
			const int wideWidth, const int barHeight, const bool security, int dataColumns, int mode, 
			int encodeRow);
int PrintMicroPDF(const char *barcodeData, const int xPos, const int yPos, int moduleWidth, 
			int barHeight, int mode, int rotation);
int PrintGS1DataBar(const char *barcodeData, const int xPos, const int yPos, int barcodeType, int expand,
			int separatorHeight, int barHeight, int segmentWidth, int rotation);

int PrintBitmap(const char *imagePath, const int xPos, const int yPos, const bool compress);

int CheckPrinterStatus();
