#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <pthread.h>
#include <wchar.h>

#include "BxlPosAPI.h"
#include "bxlConst.h"

bool gEnableStatus;

int connectToPrinter()
{
	int input;
	int ret;
	char port[128] = {0x00, };

	printf("\n\t [Connect to the Bixolon printer] \n");
	printf("\t\t  1.USB\n");
	printf("\t\t  2.Serial\n");
	printf("\t\t  3.Parallel\n");
	printf("\t\t  4.Bluetooth\n");
	printf("\t\t  5.Ethernet/WLAN\n");
	printf("\t\t  6.Back to upper menu\n");
	printf("\n");

	while (1)
	{
		printf("\nPlease select the connected interface with the printer.\n");
		printf("Input number : ");
		scanf("%d", &input);

		if (1 == input)
		{
			ret = ConnectToPrinter("USB:");
		}
		else if (2 == input)
		{
			unsigned long baudrate = 0;

			while (1)
			{
				printf("\nPlease input the baudrate of serial I/F\n");
				printf("Input number : ");
				scanf("%lu", &baudrate);

				if (2400 != baudrate && 4800 != baudrate && 9600 != baudrate && 19200 != baudrate && 
						38400 != baudrate && 57600 != baudrate && 115200 != baudrate)
				{
					printf("\nWrong input. %lu\n", baudrate);
					continue;
				}

				break;
			}

			sprintf(port, "serial:%lu", baudrate);

			// input type
			// serial:baudrate
			// /dev/ttyX:baudrate
			ret = ConnectToPrinter(port);
		}
		else if (3 == input)
		{
			// input type
			// parallel
			// /dev/lpX
			ret = ConnectToPrinter("parallel");
		}
		else if (4 == input)
		{
			while (1)
			{
				printf("\nPlease input the mac address of bluetooth priner\n");
				printf("Input the address : ");
				scanf("%s", port);


				if (':' == port[2] && ':' == port[5] && ':' == port[8] &&
						':' == port[11] && ':' == port[14])
				{
					break;
				}

				printf("\nWrong input.\n");
			}

			// input type
			// xx:xx:xx:xx:xx:xx
			ret = ConnectToPrinter(port);
		}
		else if (5 == input)
		{
			char *tmp;

			while (1)
			{
				printf("\nPlease input the IP address of Ethernet or Wlan printer\n");
				printf("Input the address : ");
				scanf("%s", port);

				tmp = strchr(port, ':');
				if (NULL == tmp)
				{
					printf("\nWrong input.\n");

					continue;
				}

				break;
			}

			// input type
			// xxx.xxx.xxx.xxx:xxxx
			ret = ConnectToPrinter(port);
		}
		else if (6 == input)
		{
			return input;
		}
		else 
		{
			printf("\nWrong input.\n\n");

			continue;
		}

		if (SUCCESS == ret)
		{
			break;
		}
		else
		{
			printf("\nFailed to connect to the printer.\n");
			sleep(1);
		}
	}

	printf("\nSuccessed to connect to the printer.\n");
	sleep(1);

	return ret;
}


int setProperties()
{
	int input;
	int ret = SUCCESS;

	printf("\n\t [Set the Properties of the printer] \n");
	printf("\t\t  1. Left Margin\n");
	printf("\t\t  2. Upside Down\n");
	printf("\t\t  3. International Character Set\n");
	printf("\t\t  4. Charactore Set\n");
	printf("\t\t  5. Back to upper menu\n");
	printf("\n");

	while (1)
	{
		printf("\nPlease select the property to set.\n");
		printf("Input number : ");
		scanf("%d", &input);


		if (1 == input)		// Left Margin
		{
			int margin;

			printf("[Set Left Margin]\n");
			printf("\nInput the Margin (1 ~ 65535): ");
			scanf("%d", &margin);

			ret = SetLeftMargin(margin);
			if (SUCCESS != ret)
			{
				printf("Failed to set left margin\n");

				return ret;
			}
			
			printf("Success to set left margin\n");
		}
		else if (2 == input)	// Upside Down 
		{
			int upsideDown; 

			printf("[Set Upside-Down]\n");
			printf("Enable the Upside-Down (1 : on, 2 : off) : ");
			scanf("%d", &upsideDown);

			if (1 == upsideDown)
			{
				ret = SetUpsideDown(true);
			}
			else
			{
				ret = SetUpsideDown(false);
			}

			if (SUCCESS != ret)
			{
				printf("Failed to set upside-down\n");

				return ret;
			}

			printf("Success to set upside-down\n");
		}
		else if (3 == input)	// International Character Set
		{
			int iCH;

			printf("\n\t [Set International Character]\n");
			printf("\n");
			printf("\t\t  1. USA\n");
			printf("\t\t  2. FRANCE\n");
			printf("\t\t  3. GERMANY\n");
			printf("\t\t  4. U.K\n");
			printf("\t\t  5. DENMARK I\n");
			printf("\t\t  6. SWEDEN\n");
			printf("\t\t  7. ITALY\n");
			printf("\t\t  8. SPAIN I\n");
			printf("\t\t  9. NORWAY\n");
			printf("\t\t  10. DENMARK II\n");
			printf("\t\t  11. SPAIN II\n");
			printf("\t\t  12. LATIN AMERICA\n");
			printf("\t\t  13. KOREA\n");

			printf("\nInput number : ");
			scanf("%d", &iCH);

			switch (iCH)
			{
				case 1:
					ret = SetInternationalChar(ICS_USA);
					break;
				case 2:
					ret = SetInternationalChar(ICS_FRANCE);
					break;
				case 3:
					ret = SetInternationalChar(ICS_GERMANY);
					break;
				case 4:
					ret = SetInternationalChar(ICS_UK);
					break;
				case 5:
					ret = SetInternationalChar(ICS_DENMARK1);
					break;
				case 6:
					ret = SetInternationalChar(ICS_SWEDEN);
					break;
				case 7:
					ret = SetInternationalChar(ICS_ITALY);
					break;
				case 8:
					ret = SetInternationalChar(ICS_SPAIN);
					break;
				case 9:
					ret = SetInternationalChar(ICS_NORWAY);
					break;
				case 10:
					ret = SetInternationalChar(ICS_DENMARK2);
					break;
				case 11:
					ret = SetInternationalChar(ICS_SPAIN2);
					break;
				case 12:
					ret = SetInternationalChar(ICS_LATIN);
					break;
				case 13:
					ret = SetInternationalChar(ICS_KOREA);
					break;
			}

			if (SUCCESS != ret)
			{
				printf("Failed to set international character set.\n");

				return ret;
			}

			printf("Success to set international character set.\n");
		}
		else if (4 == input)	// Character Set
		{
			int ch;

			printf("\n\t [Set Character]\n");
			printf("\n");
			printf("\t\t  1.PC437\n");		
			printf("\t\t  2.KATAKANA\n");	
			printf("\t\t  3.PC850\n");	
			printf("\t\t  4.PC860\n");	
			printf("\t\t  5.PC863\n");	
			printf("\t\t  6.PC865\n");	
			printf("\t\t  7.WPC1252\n");	
			printf("\t\t  8.PC866\n");	
			printf("\t\t  9.PC852\n");	
			printf("\t\t  10.PC858\n");	
			printf("\t\t  11.PC864\n");	
			printf("\t\t  12.PC874\n");	
			printf("\t\t  13.WPC1253\n");	
			printf("\t\t  14.WPC1254\n");	
			printf("\t\t  15.WPC1257\n");	
			printf("\t\t  16.FARSI\n");	
			printf("\t\t  17.WPC1251\n");	
			printf("\t\t  18.PC737\n");	
			printf("\t\t  19.PC775\n");	
			printf("\t\t  20.THAI14\n");	
			printf("\t\t  21.PC862\n");	
			printf("\t\t  22.PC855\n");	
			printf("\t\t  23.PC857\n");	
			printf("\t\t  24.PC928\n");	
			printf("\t\t  25.THAI16\n");	
			printf("\t\t  26.WPC1256\n");	
			printf("\t\t  27.PC1258\n");	
			printf("\t\t  28.KHMER\n");	
			printf("\t\t  29.PC1250\n");	
 
			printf("\nInput number : ");
			scanf("%d", &ch);

			ret = SetCharSet(ch - 1);

			if (SUCCESS != ret)
			{
				printf("Failed to set chracter set.\n");

				return ret;
			}

			printf("Success to set chracter set.\n");
		}
		else if (5 == input)
		{
			return input;
		}
		else
		{
			printf("\nWrong input.\n\n");

			continue;
		}
	}

	return SUCCESS;
}

int printSample()
{
	PrintText("            RECEIPT          \n", ALIGNMENT_CENTER, ATTR_FONTTYPE_A, TS_HEIGHT_0 | TS_WIDTH_0);
	PrintText("------------------------------\n", ALIGNMENT_CENTER, ATTR_FONTTYPE_A, TS_HEIGHT_0 | TS_WIDTH_0);
	PrintText(" Apple         3         $3.0\n", ALIGNMENT_CENTER, ATTR_FONTTYPE_A, TS_HEIGHT_0 | TS_WIDTH_0);
	PrintText(" Cola          1         $1.2\n", ALIGNMENT_CENTER, ATTR_FONTTYPE_A, TS_HEIGHT_0 | TS_WIDTH_0);
	PrintText(" Milk          2         $1.8\n", ALIGNMENT_CENTER, ATTR_FONTTYPE_A, TS_HEIGHT_0 | TS_WIDTH_0);
	PrintText(" Juice         1         $2.0\n", ALIGNMENT_CENTER, ATTR_FONTTYPE_A, TS_HEIGHT_0 | TS_WIDTH_0);
	PrintText("------------------------------\n", ALIGNMENT_CENTER, ATTR_FONTTYPE_A, TS_HEIGHT_0 | TS_WIDTH_0);
	PrintText(" Total                   $8.0\n", ALIGNMENT_CENTER, ATTR_BOLD, TS_HEIGHT_0 | TS_WIDTH_0);
	PrintText(" Cash                    $8.0\n", ALIGNMENT_CENTER, ATTR_BOLD, TS_HEIGHT_0 | TS_WIDTH_0);
	PrintText("                         $0.0\n", ALIGNMENT_CENTER, ATTR_BOLD, TS_HEIGHT_0 | TS_WIDTH_0);


	PrintText("ABCDEFabcdef\n", ALIGNMENT_CENTER, ATTR_FONTTYPE_A, TS_HEIGHT_0 | TS_WIDTH_0);
	PrintText("ABCDEFabcdef\n", ALIGNMENT_CENTER, ATTR_FONTTYPE_B, TS_HEIGHT_0 | TS_WIDTH_0);
	PrintText("ABCDEFabcdef\n", ALIGNMENT_CENTER, ATTR_FONTTYPE_C, TS_HEIGHT_0 | TS_WIDTH_0);

	LineFeed(5);

	return SUCCESS;
}

int printText()
{
	char *testMsg = "BIXOLON LINUX SDK TEST.\n\n";
	char *test = "한국어";

	SetTextEncoding(ENCODING_EUCKR);
	PrintText(test, ALIGNMENT_LEFT, ATTR_FONTTYPE_A, TS_HEIGHT_0 | TS_WIDTH_0);
	PrintText("\n\n", ALIGNMENT_LEFT, ATTR_FONTTYPE_A, TS_HEIGHT_0 | TS_WIDTH_0);

	PrintText(testMsg, ALIGNMENT_LEFT, ATTR_FONTTYPE_A, TS_HEIGHT_0 | TS_WIDTH_0);
	PrintText(testMsg, ALIGNMENT_CENTER, ATTR_FONTTYPE_B, TS_HEIGHT_0 | TS_WIDTH_0);
	PrintText(testMsg, ALIGNMENT_RIGHT, ATTR_FONTTYPE_C, TS_HEIGHT_0 | TS_WIDTH_0);
	
	PrintText(testMsg, ALIGNMENT_LEFT, ATTR_FONTTYPE_A | ATTR_BOLD, TS_HEIGHT_1 | TS_WIDTH_1);
	PrintText(testMsg, ALIGNMENT_CENTER, ATTR_FONTTYPE_B | ATTR_BOLD | ATTR_REVERSE, TS_HEIGHT_1 | TS_WIDTH_1);
	PrintText(testMsg, ALIGNMENT_RIGHT, ATTR_FONTTYPE_C | ATTR_BOLD | ATTR_UNDERLINE_1, TS_HEIGHT_1 | TS_WIDTH_1);

	return SUCCESS;
}

int printBarcode()
{
	char *barcodeData = "123456789012";
	barcodeInfo_s barcodeInfo;

	PrintText("UPCA\n", ALIGNMENT_LEFT, ATTR_FONTTYPE_A, TS_HEIGHT_0 | TS_WIDTH_0);
	barcodeInfo.height = 50;
	barcodeInfo.width = 2;
	barcodeInfo.textPosition = BARCODE_TEXT_BELOW;
	PrintBarcode(BARCODE_UPCA, barcodeData, &barcodeInfo);
	LineFeed(2);

	PrintText("UPCE\n", ALIGNMENT_LEFT, ATTR_FONTTYPE_A, TS_HEIGHT_0 | TS_WIDTH_0);
	barcodeInfo.height = 50;
	barcodeInfo.width = 2;
	barcodeInfo.textPosition = BARCODE_TEXT_BELOW;
	PrintBarcode(BARCODE_UPCE, barcodeData, &barcodeInfo);
	LineFeed(2);

	PrintText("EAN13\n", ALIGNMENT_LEFT, ATTR_FONTTYPE_A, TS_HEIGHT_0 | TS_WIDTH_0);
	barcodeInfo.height = 50;
	barcodeInfo.width = 2;
	barcodeInfo.textPosition = BARCODE_TEXT_BELOW;
	PrintBarcode(BARCODE_EAN13, barcodeData, &barcodeInfo);
	LineFeed(2);

	PrintText("JAN13\n", ALIGNMENT_LEFT, ATTR_FONTTYPE_A, TS_HEIGHT_0 | TS_WIDTH_0);
	barcodeInfo.height = 50;
	barcodeInfo.width = 2;
	barcodeInfo.textPosition = BARCODE_TEXT_BELOW;
	PrintBarcode(BARCODE_JAN13, barcodeData, &barcodeInfo);
	LineFeed(2);

	PrintText("EAN8\n", ALIGNMENT_LEFT, ATTR_FONTTYPE_A, TS_HEIGHT_0 | TS_WIDTH_0);
	barcodeInfo.height = 50;
	barcodeInfo.width = 2;
	barcodeInfo.textPosition = BARCODE_TEXT_BELOW;
	PrintBarcode(BARCODE_EAN8, "12345678", &barcodeInfo);
	LineFeed(2);

	PrintText("JAN8\n", ALIGNMENT_LEFT, ATTR_FONTTYPE_A, TS_HEIGHT_0 | TS_WIDTH_0);
	barcodeInfo.height = 50;
	barcodeInfo.width = 2;
	barcodeInfo.textPosition = BARCODE_TEXT_BELOW;
	PrintBarcode(BARCODE_JAN8, "12345678", &barcodeInfo);
	LineFeed(2);

	PrintText("Code 39\n", ALIGNMENT_LEFT, ATTR_FONTTYPE_A, TS_HEIGHT_0 | TS_WIDTH_0);
	barcodeInfo.height = 50;
	barcodeInfo.width = 2;
	barcodeInfo.textPosition = BARCODE_TEXT_BELOW;
	PrintBarcode(BARCODE_CODE39, barcodeData, &barcodeInfo);
	LineFeed(2);
	
	PrintText("Code 93\n", ALIGNMENT_LEFT, ATTR_FONTTYPE_A, TS_HEIGHT_0 | TS_WIDTH_0);
	barcodeInfo.height = 50;
	barcodeInfo.width = 2;
	barcodeInfo.textPosition = BARCODE_TEXT_BELOW;
	PrintBarcode(BARCODE_CODE93, barcodeData, &barcodeInfo);
	LineFeed(2);

	PrintText("Code 128\n", ALIGNMENT_LEFT, ATTR_FONTTYPE_A, TS_HEIGHT_0 | TS_WIDTH_0);
	barcodeInfo.height = 50;
	barcodeInfo.width = 2;
	barcodeInfo.textPosition = BARCODE_TEXT_BELOW;
	PrintBarcode(BARCODE_CODE128, barcodeData, &barcodeInfo);
	LineFeed(2);

	PrintText("ITF\n", ALIGNMENT_LEFT, ATTR_FONTTYPE_A, TS_HEIGHT_0 | TS_WIDTH_0);
	barcodeInfo.height = 50;
	barcodeInfo.width = 2;
	barcodeInfo.textPosition = BARCODE_TEXT_BELOW;
	PrintBarcode(BARCODE_ITF, barcodeData, &barcodeInfo);
	LineFeed(2);

	PrintText("Codabar\n", ALIGNMENT_LEFT, ATTR_FONTTYPE_A, TS_HEIGHT_0 | TS_WIDTH_0);
	barcodeInfo.height = 50;
	barcodeInfo.width = 2;
	barcodeInfo.textPosition = BARCODE_TEXT_BELOW;
	PrintBarcode(BARCODE_CODABAR, barcodeData, &barcodeInfo);
	LineFeed(2);

	
	// ************************************** 2D barcode

	PrintText("PDF417\n", ALIGNMENT_LEFT, ATTR_FONTTYPE_A, TS_HEIGHT_0 | TS_WIDTH_0);
	barcodeInfo.height = 0;
	barcodeInfo.width = 2;
	barcodeInfo.attribute = 0;
	PrintBarcode(BARCODE_PDF417, barcodeData, &barcodeInfo);
	LineFeed(2);

	PrintText("QRCODE\n", ALIGNMENT_LEFT, ATTR_FONTTYPE_A, TS_HEIGHT_0 | TS_WIDTH_0);
	barcodeInfo.mode = BARCODE_QR_MODEL1;
	barcodeInfo.height = 0;
	barcodeInfo.width = 2;
	barcodeInfo.attribute = 0;
	PrintBarcode(BARCODE_QRCODE, barcodeData, &barcodeInfo);
	LineFeed(2);

	PrintText("QRCODE\n", ALIGNMENT_LEFT, ATTR_FONTTYPE_A, TS_HEIGHT_0 | TS_WIDTH_0);
	barcodeInfo.mode = BARCODE_QR_MODEL2;
	barcodeInfo.height = 0;
	barcodeInfo.width = 2;
	barcodeInfo.attribute = 0;
	PrintBarcode(BARCODE_QRCODE, barcodeData, &barcodeInfo);
	LineFeed(2);

	PrintText("DATAMATRIX\n", ALIGNMENT_LEFT, ATTR_FONTTYPE_A, TS_HEIGHT_0 | TS_WIDTH_0);
	barcodeInfo.height = 0;
	barcodeInfo.width = 2;
	barcodeInfo.attribute = 0;
	PrintBarcode(BARCODE_DATAMATRIX, barcodeData, &barcodeInfo);
	LineFeed(2);

	PrintText("MAXICODE\n", ALIGNMENT_LEFT, ATTR_FONTTYPE_A, TS_HEIGHT_0 | TS_WIDTH_0);
	barcodeInfo.mode = BARCODE_MAXI_MODE4;
	barcodeInfo.height = 0;
	barcodeInfo.width = 2;
	barcodeInfo.attribute = 0;
	PrintBarcode(BARCODE_MAXICODE, barcodeData, &barcodeInfo);

	LineFeed(5);

	return SUCCESS;
}

int testNVImage()
{
	int input;
	int ret = SUCCESS;

	printf("\n\t [Test NVImage Function] \n");
	printf("\t\t  1. Download NV Image\n");
	printf("\t\t  2. Print NV Image\n");
	printf("\t\t  3. Remove NV Image\n");
	printf("\t\t  4. Remove All NV Image\n");
	printf("\t\t  5. Get NV Image Key\n");
	printf("\t\t  6. Back to upper menu\n");
	printf("\n");

	while (1)
	{
		printf("\nPlease select the property to set.\n");
		printf("Input number : ");
		scanf("%d", &input);

		if (1 == input)
		{
			ret = DownloadNVImage("image.bmp", 0x01);
			if (SUCCESS != ret)
			{
				printf("Failed to download NV Image\n");

				return ret;
			}

			printf("Success to download NV Image\n");

		}
		else if (2 == input)
		{
			ret = PrintNVImage(0x01);
			if (SUCCESS != ret)
			{
				printf("Failed to print NV Image\n");

				return ret;
			}

			printf("Success to print NV Image\n");
		}
		else if (3 == input)
		{
			ret = RemoveNVImage(0x00);
			if (SUCCESS != ret)
			{
				printf("Failed to remove NV Image\n");

				return ret;
			}

			printf("Success to print NV Image\n");
		}
		else if (4 == input)
		{
			ret = RemoveAllNVImage();
			if (SUCCESS != ret)
			{
				printf("Failed to remove all NV Image\n");

				return ret;
			}

			printf("Success to remove all NV Image\n");
		}
		else if (5 == input)
		{
			char keyList[128] = {0x00,};
			unsigned int listLen = 0;
			int i = 0;

			ret = GetNVImageKeyCode(keyList, &listLen);
			if (SUCCESS != ret)
			{
				printf("Failed to get NV Image key code\n");

				return ret;
			}

			printf("Success to get NV Image key code\n");

			for (i = 0; i < listLen; i++)
			{
				printf("%02x ", keyList[i]);
			}
			printf("\n");
		}
		else if (6 == input)
		{
			return input;	
		}
	}

	return ret;
}

int testBCD()
{
	int input;
	int ret = SUCCESS;

	printf("\n\t [Test BCD Function] \n");
	printf("\t\t  1. Clear Screen\n");
	printf("\t\t  2. Display String\n");
	printf("\t\t  3. Store Image\n");
	printf("\t\t  4. Display Image\n");
	printf("\t\t  5. Clear Image\n");
	printf("\t\t  6. Back to upper menu\n");
	printf("\n");

	while (1)
	{
		printf("\nPlease select the property to set.\n");
		printf("Input number : ");
		scanf("%d", &input);

		if (1 == input)
		{
			ret = BCDEnable();
			if (SUCCESS != ret)
			{
				printf("Failed to enable the BCD\n");

				return ret;
			}

			printf("Success to enable the BCD\n");
			ret = BCDClearScreen();
			if (SUCCESS != ret)
			{
				printf("Failed to clear the screen\n");

				return ret;
			}

			printf("Success to clear the screen\n");

			ret = BCDDisable();
			if (SUCCESS != ret)
			{
				printf("Failed to disable the BCD\n");

				return ret;
			}

			printf("Success to disable the BCD\n");
		}
		else if (2 == input)
		{
			char *testMsg = "BIXOLON BCD TEST.";
			char *testMsg2 = "TEST TEST TEST.";

			ret = BCDEnable();
			if (SUCCESS != ret)
			{
				printf("Failed to enable the BCD\n");

				return ret;
			}

			printf("Success to enable the BCD\n");
			ret = BCDDisplayStringAtLine(BCD_LINE_1, testMsg);
			
			ret = BCDDisplayStringAtLine(BCD_LINE_2, testMsg2);

			if (SUCCESS != ret)
			{
				printf("Failed to display the string\n");

				return ret;
			}

			printf("Success to display the string\n");

			ret = BCDDisable();
			if (SUCCESS != ret)
			{
				printf("Failed to disable the BCD\n");

				return ret;
			}

			printf("Success to disable the BCD\n");
		}
		else if (3 == input)
		{
			ret = BCDEnable();
			if (SUCCESS != ret)
			{
				printf("Failed to enable the BCD\n");

				return ret;
			}

			printf("Success to enable the BCD\n");
			ret = BCDStoreImageFile("image.bmp", 150, 1);

			if (SUCCESS != ret)
			{
				printf("Failed to store the image\n");

				return ret;
			}

			printf("Success to store the image\n");

			ret = BCDDisable();
			if (SUCCESS != ret)
			{
				printf("Failed to disable the BCD\n");

				return ret;
			}

			printf("Success to disable the BCD\n");
		}
		else if (4 == input)
		{
			ret = BCDEnable();
			if (SUCCESS != ret)
			{
				printf("Failed to enable the BCD\n");

				return ret;
			}

			printf("Success to enable the BCD\n");
			ret = BCDDisplayImage(1, 0, 0);

			if (SUCCESS != ret)
			{
				printf("Failed to display the image\n");

				return ret;
			}

			printf("Success to display the image\n");

			ret = BCDDisable();
			if (SUCCESS != ret)
			{
				printf("Failed to disable the BCD\n");

				return ret;
			}

			printf("Success to disable the BCD\n");
		}
		else if (5 == input)
		{
			ret = BCDEnable();
			if (SUCCESS != ret)
			{
				printf("Failed to enable the BCD\n");

				return ret;
			}

			printf("Success to enable the BCD\n");
			ret = BCDClearImage(true, 0);

			if (SUCCESS != ret)
			{
				printf("Failed to clear the image\n");

				return ret;
			}

			printf("Success to clear the image\n");

			ret = BCDDisable();
			if (SUCCESS != ret)
			{
				printf("Failed to disable the BCD\n");

				return ret;
			}

			printf("Success to disable the BCD\n");
		}
		else if (6 == input)
		{
			return input;	
		}
	}
}

void *cCheckStatus(void *arg)
{
	int status = 0x00;

	while (true == gEnableStatus)
	{
		status = GetStatus();

		if (READ_TIMEOUT == status)
		{
			continue;
		}

		printf("\nstatus : %02x\n", status);
		
		if (0x00 == status)
		{
			printf("Printer Normal\n");
		}
		else 
		{
			if (status & STS_COVEROPEN)
			{
				printf("Printer Error : Cover open\n");
			}

			if (status & STS_NEAREND)
			{
				printf("Printer Error : Near end\n");
			}

			if (status & STS_PAPEREMPTY)
			{
				printf("Printer Error : Paper empty\n");
			}
		}

		printf("If you wanna quit checking ASB, please input the number 2.\n");
	}

	return NULL;
}


int checkStatus()
{
	int input;
	int error;
	pthread_t tid;
	void *res;

	printf("\n\t [Check Status] \n");
	printf("\t\t  1. Enable ASB\n");
	printf("\t\t  2. Disable ASB\n");
	printf("\n");

	while (1)
	{
		printf("\nPlease select the property to set.\n");
		printf("Input number : ");
		scanf("%d", &input);

		if (1 == input)
		{
			SetAutoStatusCheck(true);
			gEnableStatus = true;

			if (0 != (error = pthread_create(&tid, NULL, cCheckStatus, NULL)))
			{
				printf("Failed to create thread.");
				return -1;
			}
		}
		else 
		{
			SetAutoStatusCheck(false);
			gEnableStatus = false;

			pthread_join(tid, &res);

			break;
		}
	}

	return SUCCESS;
}

int main()
{
	int menu_flag = 0;
	int ret;

	unsigned int input;

	gEnableStatus = false;

	while (1)
	{
		system("clear");
		printf("\n\n   [Bixolon POS Printer SDK Sample]   \n\n");

		if (0 == menu_flag)
		{
			printf("\t 1. Connect to the printer\n");
		}
		else 
		{
			printf("\t 1. Connect to the printer\n");
			printf("\t  - Connected!\n");
		}
		printf("\t 2. Set Properties\n");
		printf("\t 3. Print Sample\n");
		printf("\t 4. Print Text\n");
		printf("\t 5. Print Barcode\n");
		printf("\t 6. Print Image\n");
		printf("\t 7. Test DirectIO\n");
		printf("\t 8. Check Status\n");
		printf("\t 9. Test Feed\n");
		printf("\t 10. Open Cash Drawer\n");
		printf("\t 11. Test NVImage\n");
		printf("\t 12. Test BCD-3000 with SRP-Q300 or SRP-Q302\n");
		printf("\t 13. Get Battery Status (SRP-Q300 or SRP-Q302)\n");
		printf("\t 14. Exit\n");

		fflush(stdin);
		input = 0x00;
		printf("  input number : ");
		scanf("%d", &input);


		if (1 == input)		// connect to the printer
		{
			ret = connectToPrinter();
			if (6 == ret)
			{
				continue;
			}

			if (SUCCESS != ret)
			{
				printf("\n Failed to connect to printer.");

				return -1;
			}

			menu_flag = 1;
		}
		else if (2 == input) 	// set properties
		{
			if (1 > menu_flag)
			{
				printf("\n **** Please connect to the printer first. ****  \n");
				continue;
			}

			ret = setProperties();
			if (7 == ret)
			{
				continue;
			}

			if (SUCCESS != ret)
			{
				printf("\n Failed to connect to printer.");
				continue;
			}

			menu_flag = 2;
		}
		else if (3 == input) 	// print sample
		{
			if (1 > menu_flag)
			{
				printf("\n **** Please connect to the printer first. ****  \n");
				continue;
			}
			
			printSample();
			LineFeed(4);
			PartialCut();

			menu_flag = 3;
		}
		else if (4 == input) 	// print text
		{
			if (1 > menu_flag)
			{
				printf("\n **** Please connect to the printer first. ****  \n");
				continue;
			}

			printText();
			LineFeed(4);
			PartialCut();

			menu_flag = 4;
		}
		else if (5 == input) 	// print barcode
		{
			if (1 > menu_flag)
			{
				printf("\n **** Please connect to the printer first. ****  \n");
				continue;
			}

			printBarcode();
			LineFeed(4);
			PartialCut();

			menu_flag = 5;
		}
		else if (6 == input) 	// print image
		{
			if (1 > menu_flag)
			{
				printf("\n **** Please connect to the printer first. ****  \n");
				continue;
			}

			//PrintImage("image.bmp", true, ALIGNMENT_CENTER);
			PrintImage("image.bmp", 150, false, ALIGNMENT_CENTER);
			//sleep(3);
			//PrintImage("image.jpg", false, ALIGNMENT_CENTER);
			//PrintImage("image.gif", false, ALIGNMENT_CENTER);
			LineFeed(10);
			PartialCut();

			menu_flag = 6;
		}
		else if (7 == input) 
		{
			if (1 > menu_flag)
			{
				printf("\n **** Please connect to the printer first. ****  \n");
				continue;
			}

			char readBuf[4] = {0x00,};
			int readLen = 0, i = 0;

			DirectIO("\x10\x04\x01", 3, readBuf, &readLen, 0); 


			printf("Read Data : ");
			for (i = 0; i < readLen; i++)
			{
				printf("%02x ", readBuf[i]);
			}
			printf("\n");

			DirectIO(NULL, 0, readBuf, &readLen, 100); 

			sleep(1);

			menu_flag = 7;
		}
		else if (8 == input) 	// check status
		{
			if (1 > menu_flag)
			{
				printf("\n **** Please connect to the printer first. ****  \n");
				continue;
			}

			checkStatus();

			menu_flag = 8;
		}
		else if (9 == input)
		{
			if (1 > menu_flag)
			{
				printf("\n **** Please connect to the printer first. ****  \n");
				continue;
			}

			LineFeed(10);
			PartialCut();

			menu_flag = 9;
		}
		else if (10 == input)
		{
			if (1 > menu_flag)
			{
				printf("\n **** Please connect to the printer first. ****  \n");
				continue;
			}

			OpenCashDrawer(200);

			menu_flag = 10;
		}
		else if (11 == input)
		{
			if (1 > menu_flag)
			{
				printf("\n **** Please connect to the printer first. ****  \n");
				continue;
			}

			ret = testNVImage();

			if (6 == ret)
			{
				continue;
			}

			menu_flag = 11;
		}
		else if (12 == input)
		{
			if (1 > menu_flag)
			{
				printf("\n **** Please connect to the printer first. ****  \n");
				continue;
			}

			ret = testBCD();
		
			if (8 == ret)
			{
				continue;
			}

			menu_flag = 12;
		}
		else if (13 == input)
		{
			if (1 > menu_flag)
			{
				printf("\n **** Please connect to the printer first. ****  \n");
				continue;
			}
			char BatteryStatus[4][7]={"FULL","HIGH","MIDDLE","LOW"};
			int batsta = getBatteryStatus();
			if(batsta == -1) printf("Failed to Get Battery Data\n");
			else printf("%s\n",BatteryStatus[batsta]);
			menu_flag = 13;
		}
		else if (14 == input) 	// exit
		{
			printf("\n **** Finish **** \n");

			menu_flag = 14;
			break;
		}
		else 
		{
			printf("Wrong Input!!\n");

			continue;
		}

	}


	return 0;
}

